pro fst_analyze_ctrcal,filename,ndinc,offsun

   focisout = fst_focisout_read(lunh, ACQHEADER=acqheader, FILENAME=filename, /NEWFILE, /RECHDR)
   fout = replicate(focisout,5000)
   fout[0] = focisout
   freq = fst_startfreq(focisout.recheader,band_id=band_id)
   fout[0].recheader.bw = band_id
   i = 1
   id = progmeter(/init,button='Abort',label='Reading progress')
   while not EOF(lunh) do begin
      focisout = fst_focisout_read(lunh,ACQHEADER=acqheader,/RECHDR)
      fout[i] = focisout
      freq = fst_startfreq(focisout.recheader,band_id=band_id)
      fout[i].recheader.bw = band_id
      i = i + 1
      res = progmeter(id,i/10000.)
      if (res eq 'Cancel') then goto,abort
   endwhile
abort:
   res = progmeter(id,/destroy)
   free_lun,lunh

   ; Truncate to actual data length
   ntot = i - 1
   fout = fout[0:ntot-1]

   ; Determine array sizes
   nf = n_elements((reform(fout[0].pwrspect))[*,0])
   nchan = fout[0].recheader.nchan
   npol = 2
   nbid = 20
   ; Declare storage for output
   ndinc = fltarr(nf,nchan,npol,nbid)
   offsun = fltarr(nf,nchan,npol,nbid)

   ; Strip out noise diode (ND) state
   nd = fout.recheader.nd
   ;Determine ND transitions
   bad = where(nd - shift(nd,1) ne 0)
   ; Flag values at transition and next sample after transition
   fout[bad].pwrspect = !values.f_nan
   fout[bad+1<(ntot-1)].pwrspect = !values.f_nan

   ; Strip out Band ID (BID) state
   bid = fout.recheader.bw
   ; Determine band transitions
   bad = where(bid - shift(bid,1) ne 0)
   ; Flag values at transition and next sample after transition
   fout[bad].pwrspect = !values.f_nan
   fout[bad+1<(ntot-1)].pwrspect = !values.f_nan
   pol = fout.recheader.pol
   id = progmeter(/init,button='Abort',label='Forming bands')
   for ibid = 0, nbid-1 do begin
      for ipol = 0, npol-1 do begin
         spec_off = reform(fout[where(bid eq ibid and pol eq ipol and nd eq 0)].pwrspect)
         spec_on = reform(fout[where(bid eq ibid and pol eq ipol and nd eq 1)].pwrspect)
         for ichan = 0, nchan-1 do begin
            for i = 0, nf-1 do begin
               spec0 = median(spec_off[i,ichan,*])
               spec1 = median(spec_on[i,ichan,*])
               ndinc[i,ichan,ipol,ibid] = spec1 - spec0
               offsun[i,ichan,ipol,ibid] = spec0
            endfor
            res = progmeter(id,(1.*ibid*(npol*nchan) + ipol*nchan + ichan)/(1.*nbid*npol*nchan))
            if (res eq 'Cancel') then goto,abort2
         endfor
      endfor
   endfor
abort2:
   res = progmeter(id,/destroy)

return
end
