;+
; NAME:
;     fst_flatten2bytestr
; PURPOSE:
;     To convert an IDL variable into a bytearray representation of a LabVIEW variant
; CATEGORY:
;     OVRO FST DATA ANALYSIS
; CALLING SEQUENCE:
;     bytestr=fst_flatten2bytestr(data,attributes=attributes)
; INPUTS:
;     data: an IDL variable
;
; OPTIONAL (KEYWORD) INPUT PARAMETERS:
;     attributes: an IDL structure whose tags to be added as variant attributes
;
; ROUTINES CALLED:
;     fst_idl2lv
; OUTPUTS:signed integer
; COMMENTS:
;
; SIDE EFFECTS:
; RESTRICTIONS:
;     some IDL data types might not be yet supported
; MODIFICATION HISTORY:
;     Written March 31-2005 by Gelu Nita (gnita@njit.edu)
function fst_flatten2bytestr,data,attributes=attributes
    if (n_elements(data) eq 0) and (n_elements(attributes) eq 0) $
    then return,[0b,0b,0b,12b,0b,4b,0b,0b,0b,0b,0b,0b] ;/empty variant
   	fst_idl2lv,data,'temp.tmp',attributes=attributes
	openr,unit,'temp.tmp',/get_lun
	status = FSTAT(unit)
	result=bytarr(status.size)
	readu,unit,result
	free_lun,unit
	file_delete,'temp.tmp'
	return,result
end