;+
; NAME:
;       fst_lv2idl
;
; PURPOSE:
;       This function restores as an IDL structure a LabVIEW variant record
;
; CATEGORY:
;       Data readers
;
; CALLING SEQUENCE:
;        result=fst_lv2idl([file])
;
; INPUTS:
;       FILE: The datalog file name. If not provided,the user is asked for a filename..
;
; OUTPUTS:
;       None
; KEYWORD PARAMETERS:
; REFERENCE:
;       National Instruments Application Note 154
;
; RESTRICTIONS:
;
; DISCLAIMER:
;       Use this program at your own risk.
;
; MODIFICATION HISTORY:
;       Written by:  Gelu M. Nita (gnita@njit.edu), Jan 11, 2006
;-

function fst_lv2idl,file
 if n_elements(file) eq 0 then file=dialog_pickfile()
 openr,unit,file,/get_lun,/SWAP_IF_LITTLE_ENDIAN
 return,fst_variant(unit,/free)
end