;+
; NAME:
;     fst_lvcode70
; PURPOSE:
;     Returns the LabView 7.0 type codes into an IDL structure
; CATEGORY:
;     OVRO FST DATA ANALYSIS
; CALLING SEQUENCE:
;     codes=lavcodes()
; INPUTS:
; OPTIONAL (KEYWORD) INPUT PARAMETERS:
; ROUTINES CALLED:
; OUTPUTS:IDL structure
; COMMENTS:
;    LABVIEW 7.0 TYPE CODES and DESCRIPTORS
;	8-bit Integer 01 0004 xx01
;	16-bit Integer 02 0004 xx02
;	32-bit Integer 03 0004 xx03
;	Unsigned 8-bit Integer 05 0004 xx05
;	Unsigned 16-bit Integer 06 0004 xx06
;	Unsigned 32-bit Integer 07 0004 xx07
;	Single-Precision Floating-Point Number 09 0004 xx09
;	Double-Precision Floating-Point Number 0A 0004 xx0A
;	Extended-Precision Floating-Point Number 0B 0004 xx0B
;	Single-Precision Complex Floating-Point Number 0C 0004 xx0C
;	Double-Precision Complex Floating-Point Number 0D 0004 xx0D
;	Extended-Precision Complex Floating-Point Number 0E 0004 xx0E
;	Enumerated 8-bit Integer 15 <nn> xx15 <k> <k pstrs>
;	Enumerated 16-bit Integer 16 <nn> xx16 <k> <k pstrs>
;	Enumerated 32-bit Integer 17 <nn> xx17 <k> <k pstrs>
;	Single-Precision Physical Quantity 19 <nn> xx19 <k> <k base-exp>
;	Double-Precision Physical Quantity 1A <nn> xx1A <k> <k base-exp>
;	Extended-Precision Physical Quantity 1B <nn> xx1B <k> <k base-exp>
;	Single-Precision Complex Physical Quantity 1C <nn> xx1C <k> <k base-exp>
;	Double-Precision Complex Physical Quantity 1D <nn> xx1D <k> <k base-exp>
;	Extended-Precision Complex Physical Quantity 1E <nn> xx1E <k> <k base-exp>
;	Boolean 21 0004 xx21
;	String 30 0008 xx30 <dim>
;	Path 32 0008 xx32 <dim>
;	Pict 33 0008 xx33 <dim>
;	Array 40 <nn> xx40 <k> <k dims> <element type descriptor>
;	Cluster 50 <nn> xx50 <k> <k element type descriptors>
;	Waveform 54 <nn> xx54 <waveform type> <element type descriptors>
;	Refnum 70 <nn> <refnum type code><specific type code information>
;	Variant 53 <nn> xx53
;   n=length; x=reserved; k=number; k pstrs=number of Pascal strings; k base-exp=number of base-exponent pairs.
;   Refer to the Physical Quantity section of LabView documentation for more information.
; SIDE EFFECTS:
; RESTRICTIONS: Only some of the LabView type codes are returned by this function. More will be added as needed.
; MODIFICATION HISTORY:
;     Written 25-Jan-2005 by Gelu Nita
;     6-March-2006 rewriten entirely
;
;-

;--------------------------------------------------------------------------


function fst_lvcode70
    return,{empty:0,i8:1,i16:2,i32:3,u8:5,u16:6,u32:7,single:9,double:10,$
    complex:12,dcomplex:13,$
    string:48,array:64,cluster:80,variant:83,waveform:84,e8:21,e16:22,e32:23,typedef:241,boolean:33}
end

