
pro to_plotman,state,id
  psys=*(state.psys)
  temp=fst_ut(psys[0].timestamp,utbase=utbase)
  chanid=psys.chanid
  time=fst_ut(psys.timestamp)
  data=psys.data
  good=where(chanid eq id, count)
  if count gt 0 then begin
   data=[[time[good]],[data[good]]]
  end
end


pro plot_data,state

if ptr_valid(state.psys) eq 0 then return
psys=*(state.psys)
 temp=fst_ut(psys[0].timestamp,utbase=utbase)
 chanid=psys.chanid
 time=fst_ut(psys.timestamp)
 data=psys.data
 psave=!p
 dwindow = !d.window
 wset,state.wpmap
 first=0
 color=[0,250,50,150]
 for i=1b, 4 do begin
  id=where(chanid eq i,count)
  if count gt 0 then begin
   if first eq 0 then begin
	 utplot,time[id],data[id],utbase,title ='PSYS History',ytitle='(dBm)',$
	        background=255,color=0,/xsty,yrange=state.yrange
	  first=1
   endif else outplot,time[id],data[id],color=color[i-1]
  end
 end
 wset,state.wdraw
 device,copy=[0,0,state.wxsize,state.wysize,0,0,state.wpmap]
 !p=psave
 if (dwindow ne !d.window) and (dwindow ge 0) then begin
  device, window_state=window_state
  if n_elements(window_state) gt dwindow then     $
     if window_state(dwindow) then wset, dwindow
 endif
end

; Event-handler routine
;
PRO fst_monitor_event, event

  COMPILE_OPT hidden


  ; Retrieve the anonymous structure contained in the user value of
  ; the top-level base widget.
   base = Event.handler
   WIDGET_CONTROL, base, GET_UVALUE=state

   CATCH, Error_status
   IF Error_status NE 0 THEN BEGIN
      case !ERROR_STATE.MSG of
      else:begin
            result=dialog_message(!ERROR_STATE.MSG,/error)
            goto,write_state
           end
      endcase
   ENDIF

   IF (TAG_NAMES(Event, /STRUCTURE_NAME) EQ $
                            'WIDGET_KILL_REQUEST') THEN BEGIN

   quit:
   answer=dialog_message('Exit FST MONITOR?',Title='FST MONITOR',/cancel)
   if answer eq 'Cancel' then goto, write_state
     WIDGET_CONTROL, Event.top, /DESTROY

     free_lun,state.unit
     state=0
     heap_gc
    RETURN
   ENDIF

   CASE event.id of
    state.timer: begin
                  if ptr_valid(state.psys) gt 0 then psys=*(state.psys)
                  fst_getpsys, state.unit,psys=psys
                  if size(psys,/type) eq 0 then (psys_ptr=ptr_new()) else (psys_ptr=ptr_new(psys))
                  ptr_free,state.psys
                  state.psys=psys_ptr
                  plot_data,state
                  WIDGET_CONTROL, state.timer, TIMER=1.0
                 end
    ELSE: BEGIN
           WIDGET_CONTROL, event.id, GET_VALUE=Name
           if size(name,/tname) ne 'STRING' then Name=''
           case name of
            'Exit':goto,quit
            'PSYS 1':to_plotman,state,1
            'PSYS 2':to_plotman,state,2
            'PSYS 3':to_plotman,state,3
            'PSYS 4':to_plotman,state,4
           else:
           endcase
          END
   ENDCASE


   write_state:
   WIDGET_CONTROL, base, SET_UVALUE=state

   RETURN
END


pro fst_monitor,file,GROUP=group
  if n_elements(file) eq 0 then file='psys.bin'
  template={chanid:0l,timestamp:0d,data:0d}
  openr,unit,file,/swap_if_little,/get_lun
  fst_getpsys, unit,psys=psys
  if size(psys,/type) eq 0 then (psys_ptr=ptr_new()) else (psys_ptr=ptr_new(psys))

  if (not keyword_set(group)) then group = 0
   base = WIDGET_BASE(/COLUMN ,/TLB_KILL_REQUEST_EVENTS,$
                      TITLE='FST MONITOR',GROUP = group, $
                      XOFFSET=10,YOFFSET=10,  $
                      EVENT_PRO = 'fst_monitor_event',$
                      mbar=mbar)
   w_file = widget_button (mbar, value='File', /menu)
   w_exit = widget_button (w_file, value='Exit')
   w_plotman = widget_button (mbar, value='Plotman', /menu)
   for i=1,4 do begin
    find=where(psys.chanid eq i,count)
    if count gt 0 then $
      w_plot=widget_button (w_plotman, uvalue=i,value=String(i,format="('PSYS ',i1)"))
   end
   wxsize = 500
   wysize = 200
   device,decompos=0
   loadct,39  ; Load rainbox color table

wdraw = WIDGET_DRAW(base,xsize=wxsize,ysize=wysize)
; Open a pixmap window of the same size as the draw widget
WINDOW,/free,/pixmap,xsize=wxsize,ysize=wysize
wpmap = !d.window
;Define a timer

timer=WIDGET_Label(base,/dynamic_resize,value='',Font='Arial*bold*20')

WIDGET_CONTROL, Base, /REALIZE, update=0
WIDGET_CONTROL, timer, TIMER=0.1
WIDGET_CONTROL,wdraw,GET_VALUE=wdraw

state = {self:base,mbar: mbar, w_file: w_file,wdraw:wdraw,wpmap:wpmap,$
         timer:timer,wxsize:wxsize,wysize:wysize,psys:psys_ptr,yrange:[-30,0],unit:unit}

widget_control, base, set_uvalue=state
widget_control, base, /map, /update, /show
XMANAGER, 'FST_MONITOR', Base, /NO_BLOCK
plot_data,state
end