FUNCTION FST_PROCESS_FILTERBLOCK, fblock, rejectchantab
;
; Returns filtered version of a datablock
;
; Input is a nsamperfblock x nchan floating point array
;
;  5-Sep-05 	Initial version (ghurford@ssl.berkeley.edu)
;				Just sets bad frequencies to zero.
;  7-Sep-05 gh	Eliminate the residual imaginary component in fblockout to return a floating point array
;
fftb = FFT(fblock, DIMENSION=1)							; Output is an nfreq x nchan complex array
fftb[rejectchantab,*] = 0
fblockout = ABS(FFT(fftb, DIMENSION=1, /INVERSE))	; Eliminates the very small imaginary component
RETURN, fblockout
END